# -*- coding: utf-8 -*-

# Copyright 2016 Mir Calculate. http://www.calculate-linux.org
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import sys
from calculate.lib.datavars import (ReadonlyVariable, Variable,
                                    VariableInterface, VariableError)
from calculate.lib.utils.common import genpassword
from calculate.lib.utils.tools import repeater

_ = lambda x: x
from calculate.lib.cl_lang import (setLocalTranslate, getLazyLocalTranslate)

setLocalTranslate('cl_unix3', sys.modules[__name__])
__ = getLazyLocalTranslate(_)


class HashHelper(VariableInterface):
    """
    Хэш пароля для LDAP
    """
    source = ""
    hash_var = "ld_encrypt"

    def get(self):
        return SlapPasswd(self.Get(self.hash_var)).get_hash(
            self.Get(self.source))


class RandomPasswordHelper(VariableInterface):
    """
    Генератор пароля
    """
    password_len = 9

    def get(self):
        return genpassword(self.password_len).strip()


